@ECHO OFF
REM #############################################################
REM                CodeTyphon Studio 
REM      Copyright  PilotLogic Software House.
REM               All rights reserved.
REM #############################################################

REM cbFPCType=%1
REM cbFPCCPUOS=%2
REM cbFPCStartEXE=%3
REM cbTARGETCPU=%4
REM cbTARGETOS=%5
REM cbFPCCrossEXE=%6
REM cbParam=%7

IF '%1'=='' GOTO GO_END
IF '%2'=='' GOTO GO_END
IF '%3'=='' GOTO GO_END
IF '%4'=='' GOTO GO_END
IF '%5'=='' GOTO GO_END
IF '%6'=='' GOTO GO_END
IF '%7'=='' GOTO GO_END

IF '%2'=='%4-%5' GOTO GO_END

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@ 

ECHO.
ECHO =====================================================================
ECHO          %1 Build Cross for %4-%5 Param:%7 Level-2
ECHO =====================================================================

if NOT EXIST ..\..\fpcsrc\Makefile.fpc (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO   [ERROR]: FreePascal directory NOT Exists  
ECHO          sorry, build STOP 
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
)

if NOT EXIST ..\..\fpc\bin\%2\make.exe (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO   [ERROR]: Make.exe for %1 NOT Exists  
ECHO          sorry, build STOP 
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
)

IF EXIST ..\..\binToolchains\%1-%4-%5--%7 (
ECHO [INFO]: Copy Files from ToolsChains Library...
copy /Y ..\..\binToolchains\%1-%4-%5--%7\*.* C:\codetyphon\fpc\bin\%2\

) ELSE (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO   [ERROR]: Can NOT find %1 files for %1-%4-%5--%7 
ECHO            in Toolschains Library.               
ECHO            sorry, Cross Build procedure STOP 
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
)

REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

ECHO. 
ECHO ----------------------------------------------------------------
ECHO       Stage 0: Clean FreePascal Directory
ECHO ----------------------------------------------------------------
ECHO.
START /B /WAIT x_FPC_%1%_Clean

ECHO. 
ECHO ----------------------------------------------------------------
ECHO       Stage 1: Build Cross Compiler Executable
ECHO ----------------------------------------------------------------
ECHO.

START /D C:\codetyphon\fpcsrc\ /B /WAIT C:\codetyphon\fpc\bin\%2\make.exe compiler_cycle FPC=%3.exe
START /D C:\codetyphon\fpcsrc\ /B /WAIT C:\codetyphon\fpc\bin\%2\make.exe -C utils/fpcm all FPC=%3.exe
START /D C:\codetyphon\fpcsrc\ /B /WAIT C:\codetyphon\fpc\bin\%2\make.exe all CPU_TARGET=%4 OS_TARGET=%5 OPT="-dFPC_ARMHF" BINUTILSPREFIX=%4-%5- FPC=%3.exe


if NOT EXIST C:\codetyphon\fpcsrc\compiler\%6.exe (
ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO   [ERROR]:  %1 Cross compiler %6.exe NOT Builded
ECHO           sorry, build STOP   
ECHO ???????????????????????????????????????????????????????????
ECHO.
EXIT
) ELSE (
copy /Y C:\codetyphon\fpcsrc\compiler\%6.exe C:\codetyphon\fpc\bin\%2\
ECHO.
ECHO [INFO]: !!! Cross compiler Executable %6.exe for %1, Build OK. !!!
)

ECHO. 
ECHO ----------------------------------------------------------------
ECHO        Stage 2: Build All Units and Packages  
ECHO ----------------------------------------------------------------
ECHO.

START /D C:\codetyphon\fpcsrc\ /B /WAIT C:\codetyphon\fpc\bin\%2\make.exe -C rtl clean CPU_TARGET=%4 OS_TARGET=%5 BINUTILSPREFIX=%4-%5- FPC=%6.exe
START /D C:\codetyphon\fpcsrc\ /B /WAIT C:\codetyphon\fpc\bin\%2\make.exe -C packages clean CPU_TARGET=%4 OS_TARGET=%5 BINUTILSPREFIX=%4-%5- FPC=%6.exe
START /D C:\codetyphon\fpcsrc\ /B /WAIT C:\codetyphon\fpc\bin\%2\make.exe rtl packages CPU_TARGET=%4 OS_TARGET=%5 BINUTILSPREFIX=%4-%5- FPC=%6.exe OPT="-CaEABIHF -CpARMV6 -CfVFPV2 -OoFASTMATH"

ECHO. 
ECHO ----------------------------------------------------------------
ECHO        Stage 3: Install All Units and Packages  
ECHO ----------------------------------------------------------------
ECHO.

START /D C:\codetyphon\fpcsrc\ /B /WAIT C:\codetyphon\fpc\bin\%2\make.exe rtl_install packages_install CPU_TARGET=%4 OS_TARGET=%5 BINUTILSPREFIX=%4-%5- FPC=%6.exe PREFIX=C:\codetyphon\fpc 

ECHO. 
ECHO ----------------------------------------------------------------
ECHO        Stage 4: Clean FreePascal Directory 
ECHO ----------------------------------------------------------------
ECHO.

START /B /WAIT x_FPC_%1%_Clean

REM ------------------------- Check------------------------------------

if EXIST C:\codetyphon\fpc\units\%4-%5\rtl\system.ppu GOTO GO_ALL_OK

ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO  [ERROR]: %1 Cross Element for %4-%5 Param:%7 NOT Exists 
ECHO         sorry, build STOP
ECHO ???????????????????????????????????????????????????????????
ECHO.

EXIT
REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

:GO_ALL_OK

if EXIST ..\..\allzips\bingdb\%1-%4-%5.7z (
..\..\binBase\i386-win32\7zr.exe x ..\..\allzips\bingdb\%1-%4-%5.7z -o..\..\binGDB\ -y
)

ECHO.
ECHO [FINAL INFO]: -- !!! %1 %4-%5 Param:%7 Cross Build Element Build OK !!! --
ECHO.

EXIT
REM @@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

:GO_END

ECHO.
ECHO ???????????????????????????????????????????????????????????
ECHO     [ERROR]:  Sorry NO Script Parameters. 
ECHO ???????????????????????????????????????????????????????????
ECHO.

EXIT

